<template>
  <div class="container">
    <h2>New Buff</h2>
    <b-form-input
      v-model="equipment_id"
      required
      placeholder="equipment id"
      type="number">
    </b-form-input>
    <small>In case you don't know the equipment id, visit <nuxt-link to="/admin/equipment">equipment</nuxt-link></small>
    <b-form-input
      v-model="stat"
      placeholder="stat"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="amount"
      placeholder="amount"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      equipment_id: '',
      stat: '',
      amount: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.equipment_id * (this.stat+1) * this.amount;
    }
  },
  methods: {
    submit() {
      let data = {
        buff: {
          stat: this.stat,
          amount: this.amount,
          equipment_id: this.equipment_id
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/buffs',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
